import com.sun.java.swing.JTextArea;
import com.sun.java.swing.JTree;
import com.sun.java.swing.tree.DefaultMutableTreeNode;
import com.sun.java.swing.JScrollPane;
import com.sun.java.swing.JPanel;
import com.sun.java.swing.JFrame;
import java.awt.GridLayout;
import java.awt.event.WindowListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Enumeration;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;

import com.sun.java.swing.JLabel;
import com.sun.java.swing.JTextField;
import com.sun.java.swing.event.*;
import com.sun.java.swing.tree.*;

import javax.naming.*;
import javax.naming.directory.*;

public class MDSBrowser extends Panel
{
  JLabel filterLable ;
  JTextField filterText;
  JTextField hostText,portText;
  DefaultMutableTreeNode top,rootNode ;
  String rootDir,relativeRootDir;
  DefaultMutableTreeNode stack[] = new DefaultMutableTreeNode[16];
  int  s_top=0;
  JFrame frame;
  Panel p;
   String InitialRootDir="o=WebFlow,c=US";

  public void run(){}
  
  public MDSBrowser (String host, int port) 
  {
    String ldapHost = "ldap://"+host+":"+port;
    FileTreeModel  root = new FileTreeModel(InitialRootDir,this,
		   ldapHost,"(objectclass=*)",SearchControls.SUBTREE_SCOPE);
    refreshFileBrowser(root ,InitialRootDir);
  }
 
public void refreshFileBrowser(FileTreeModel  root,String rootName)
  {
    
    //remove all the components inside the Panel
    removeAll();
    
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    setFont(new Font("Helvetica", Font.PLAIN, 14));
    setLayout(gridbag);

    selectedFile file_field = new selectedFile("",50,"file",this);
    
    DirTree tree = new DirTree(root,this);
    JScrollPane scrollPane = new JScrollPane(tree);
    tree.addMouseListener(file_field);
    tree.addTreeExpansionListener(root);
    root.addTreeModelListener(tree);
       
    c.fill = GridBagConstraints.HORIZONTAL;
    c.gridwidth = GridBagConstraints.REMAINDER;

     //Next row
    JLabel label = new JLabel("Enter Path and Folder Name :");
    gridbag.setConstraints(label, c);
    add(label);

    final selectedFile directory_field=new selectedFile(rootName,50,
					       	"directory",this);
    tree.addMouseListener(directory_field);
    directory_field.addActionListener(root);
    

    gridbag.setConstraints(directory_field, c);
    add(directory_field);

    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    c.weighty = 1.0;

    c.gridheight = 2;
    c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints(scrollPane, c);
    add(scrollPane);

    //Next row
    c.weightx = 0.0;
    c.weighty = 0.0;
    c.fill = GridBagConstraints.HORIZONTAL;
    label = new JLabel("Enter File Name :");
    gridbag.setConstraints(label, c);
    add(label);

    gridbag.setConstraints(file_field, c);
    add(file_field);

    c.fill = GridBagConstraints.NONE;

    //Next Row 
    c.fill = GridBagConstraints.NONE;
    Button button = new Button("OK");
    c.gridwidth = GridBagConstraints.RELATIVE;
    gridbag.setConstraints(button, c);
    add(button);
    button.addActionListener(file_field);
    

    button = new Button("Cancel");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints(button, c);
    add(button);
  }
  

  
   public static void main(String[] args) {
        /*
         * Create a window.  Use JFrame since this window will include 
         * lightweight components.
         */
      Panel panel;
       
      Frame frame = new Frame("TreeDemo");
     	frame.setLayout( new BorderLayout() );
      WindowListener l = new WindowAdapter() {
     public void windowClosing(WindowEvent e) {System.exit(0);}
      };
      frame.addWindowListener(l);
		
      frame.add(BorderLayout.CENTER,new MDSBrowser(args[0],
					   Integer.parseInt(args[1])));
	frame.pack();
        //frame.move(60 + drawAreaSize.width, 10);frame.setSize(500, 500);
        frame.show();
    }
     
}


class selectedFile extends JTextField implements MouseListener,ActionListener
{
public String name;
public String fullFilePath;
MDSBrowser viewer;
  
public selectedFile(String text,int colums,String name_,MDSBrowser viewer_)
  {
    super(text,colums);
    name = name_;
    addActionListener(this);
    viewer = viewer_;
  }

 public void actionPerformed(ActionEvent e) {
   if (name.equals("file")){
     System.out.println("File :"+fullFilePath+" are sent in ActionPerformed!!!");
     //ClientSocket socket = viewer.waitUntilSocketReady() ;
     //socket.send("SWING_REPLY"+fullFilePath);
   }
 }
  

public void mouseClicked(MouseEvent e) {

  String dirName=null,fileName=null;
  
  System.out.println("inside  selectedFile!!!");
  Component source = e.getComponent();
  DirTree tree = (DirTree)source;
  
  int selRow = tree.getRowForLocation(e.getX(), e.getY());
  TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
      
  if (selPath != null){
    
    fullFilePath = tree.getSelectedItem(selPath);
    int index = fullFilePath.lastIndexOf(",");
    fileName  = fullFilePath.substring(index+1);
    dirName   = fullFilePath.substring(0,index);
  
    if(selRow != -1) {
      if(e.getClickCount() == 1) {
	System.out.println("One Cliect pressed inside selectedfile !!!");
	if (name.equals("file"))
	  setText(fileName);
	else if (name.equals("directory"))
	  setText(dirName);
      }
      else if(e.getClickCount() == 2) {
	System.out.println("Two Cliect pressed inside selectedfile !!!");
	if (name.equals("file"))
	  setText(fileName);
	else if (name.equals("directory"))
	  setText(dirName);

	if ((fileName.length() > 0)&&(name.equals("file"))){
	  System.out.println("File :"+fullFilePath+" are sent!!!");
	  //ClientSocket socket = viewer.waitUntilSocketReady() ;
	  //socket.send("SWING_REPLY"+fullFilePath);
	}
      }
    }
  }
  
}
  

 public void   mouseEntered(MouseEvent e) {;  }
     
 public void     mouseExited(MouseEvent e) {;  }
      
 public void     mousePressed(MouseEvent e) {;  }
      
 public void     mouseReleased(MouseEvent e) {;  }

  
}



class DirTree extends JTree implements MouseListener,TreeModelListener
{
  JLabel filterLable ;
  JTextField filterText;
  JTextField hostText,portText;
  public DefaultMutableTreeNode top,rootNode ;
  String rootDir,relativeRootDir;
  DefaultMutableTreeNode stack[] = new DefaultMutableTreeNode[16];
  int  s_top=0;
   JFrame frame;
  Panel p;
  public MDSBrowser viewer;
  DataInputStream dis;
  DataOutputStream dos;
  
  
 public DirTree(DefaultTreeModel  root,MDSBrowser viewer_)
  {
    super(root);
    addMouseListener(this);
    viewer = viewer_;
  }


  public void mouseClicked(MouseEvent e) {

    System.out.println("inside DIRTREE !!!");
    Component source = e.getComponent();
    DirTree tree = (DirTree)source;
  
    int selRow = tree.getRowForLocation(e.getX(), e.getY());
    TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
    if(selRow != -1) {
      if(e.getClickCount() == 1) {
	System.out.println("One Cliect pressed inside DIRTREE !!!");
	//mySingleClick(selRow, selPath);
      }
      else if(e.getClickCount() == 2) {
	System.out.println("Two Cliect pressed inside DIRTREE !!!");
	fireTreeExpanded(selPath);
      }
    }
  
  }

public String getSelectedItem(TreePath selPath)
  {
    int pcount = selPath.getPathCount();
    TreeNode tn = (TreeNode)(selPath.getPathComponent(pcount-1));
    Object o = ((DefaultMutableTreeNode)tn).getUserObject();
    attributeVector tinfo = (attributeVector)o;
    String dn = (String)(tinfo.elementAt(0));
    System.out.println("Selected dn : "+dn);
    return dn;
  }

 public void   mouseEntered(MouseEvent e) {;  }
     
 public void     mouseExited(MouseEvent e) {;  }
      
 public void     mousePressed(MouseEvent e) {;  }
      
 public void     mouseReleased(MouseEvent e) {;  }
 

public void   treeNodesChanged(TreeModelEvent e)
  {
    System.out.println("treeNodesChanged is CALLED !!! ");
    
  }
  

 public void    treeNodesInserted(TreeModelEvent e) 
{
    System.out.println(" treeNodesInserted  is CALLED !!! ");
    
  }
 public void    treeNodesRemoved(TreeModelEvent e) 
{
    System.out.println("treeNodesRemoved  is CALLED !!! ");
    
  }

 public void    treeStructureChanged(TreeModelEvent e)
 {
    System.out.println("treeStructureChanged  is CALLED !!! ");
    int row = getRowForPath(e.getTreePath());
    System.out.println("treeStructureChanged:row:"+row);
    //expandRow(row);
    
    
 }      
}

class FileTreeModel extends DefaultTreeModel implements
                                         TreeExpansionListener,ActionListener
{
  
   MDSBrowser viewer;
   DefaultMutableTreeNode root;
   String ldapHost;
   String filter;
   int SearchScope;
  
public FileTreeModel(String dirFullPath,MDSBrowser viewer_,
		     String ldapHost_,String filter_,int SearchScope_)
  {
    
    super(new DefaultMutableTreeNode(new attributeVector(".")));
    viewer = viewer_;
    root   = (DefaultMutableTreeNode)(getRoot());
    ldapHost = ldapHost_;
    filter = filter_;
    SearchScope = SearchScope_;
  }


  public  DefaultMutableTreeNode findParent(attributeVector entry)
  {
	 int ns=0;
	 String dist_name,nexts,dirs[] = new String[16];
	 DefaultMutableTreeNode tnode=null;
	 Object obj;
	 attributeVector nextvec;
	 boolean flag=true;
	 String s,sstring;
	 	 	 
	
	 tnode = root;
	 obj = ((DefaultMutableTreeNode)tnode).getUserObject();
	 nextvec = (attributeVector)obj;
	 nexts = (String)(nextvec.elementAt(0));

	
	 dist_name = (String)(entry.elementAt(0));
	 //System.out.println("next :"+dist_name+" root="+nexts);
	 dist_name = dist_name.substring(0,dist_name.length()-
					 nexts.length()-1);

	 // get all the upper directory names
         StringTokenizer st = new StringTokenizer(dist_name,",",false);
         while(st.hasMoreTokens()){
           s = st.nextToken();
	   if (s.indexOf(' ') == 0)
	     s = s.substring(1);
	   dirs[ns] = s;
           //System.out.println("/"+dirs[ns]);
	   ns++;
	   
         }
	 ns--;
	 
	 while(ns > 0 ) {
	   sstring = dirs[ns]+","+nexts;
	   //System.out.println("ssstring "+sstring+" nchilds "+
      	   //   tnode.getChildCount()+" ns "+ns);
	   
	   for(int i=0;i<tnode.getChildCount();i++){
	     TreeNode tn = tnode.getChildAt(i);
	     obj = ((DefaultMutableTreeNode)tn).getUserObject();
	     attributeVector tinfo = (attributeVector)obj;
	     nexts = (String)(tinfo.elementAt(0));
	     //System.out.println("nexs in for "+nexts+" ssting "+sstring);
	     
	     if (nexts.equalsIgnoreCase(sstring)){
	       //System.out.println("I got dir name :"+nexts);
	       tnode = (DefaultMutableTreeNode)tn;
	       break;
	     }
	   }
	   ns--;
	 }
  	 return tnode;
	 
  }

public  String fixDn(String dn)
  {
    String newDn="";
    
    StringTokenizer st = new StringTokenizer(dn,",",false);
    while(st.hasMoreTokens()){
      String s = st.nextToken();
      s = s.trim();   
      newDn += s+",";
    }
    int index = newDn.lastIndexOf(',');
    newDn = newDn.substring(0,index);
    return newDn;
        
  }
  

public  attributeVector searchFull (String base)
{

    attributeVector mdsContent = new attributeVector();
  
    Hashtable env = new Hashtable(5, 0.75f);
    /*
     * Specify the initial context implementation to use.
     * This could also be set by using the -D option to the java program.
     * For example,
     *   java -Djava.naming.factory.initial=com.sun.jndi.ldap.LdapCtxFactory \
     *     Search
     */  
   env.put(Context.INITIAL_CONTEXT_FACTORY,"com.sun.jndi.ldap.LdapCtxFactory");

    /* Specify host and port to use for directory service */
   env.put(Context.PROVIDER_URL, ldapHost);//"ldap://osprey4.npac.syr.edu:2323"
   env.put(Context.REFERRAL, "follow");
   try {
        /* get a handle to an Initial DirContext */
        DirContext ctx = new InitialDirContext(env);

        /* specify search constraints to search subtree */
        SearchControls constraints = new SearchControls();
        constraints.setSearchScope(SearchScope);
	//SearchControls.SUBTREE_SCOPE);

        /* search for all entries with surname of Jensen */
        NamingEnumeration results
            = ctx.search(base, filter, constraints);
	//"o=WebFlow, c=US", "objectclass=*"

        /* for each entry print out name + all attrs and values */
        while (results != null && results.hasMore()) {
	    attributeVector oneEntry = new attributeVector();
            SearchResult si = (SearchResult)results.next();

            /* print its name */
	    //add base address to the entry dn because JNDI gives
	    //all dn's of results relative to base
	    String dn = base;
	    if (si.getName().length() > 0)
	      dn = si.getName()+","+base;
	    dn = fixDn(dn);
	
	   
	    oneEntry.addElement(dn);
            System.out.println("name: " + dn);

            Attributes attrs = si.getAttributes();
            if (attrs == null) {
                System.out.println("No attributes");
            } else {
                /* print each attribute */
                for (NamingEnumeration ae = attrs.getAll();
                     ae.hasMoreElements();) {
                    Attribute attr = (Attribute)ae.next();
                    String attrId = attr.getID();

                    /* print each value */
                    for (Enumeration vals = attr.getAll();
			 vals.hasMoreElements(); ){
		      String oneattr = (String)(vals.nextElement());
		      oneEntry.addElement(oneattr);
		      System.out.println(attrId + ": " + oneattr);
		    }
		    
						    
                }
            }
            System.out.println();
	    mdsContent.addElement(oneEntry);
	    
        }
	
    } catch (NamingException e) {
        System.err.println("Search example failed.");
        e.printStackTrace();
    }
    return mdsContent;
    
}
    

public void actionPerformed(ActionEvent e) 
{
  String base = e.getActionCommand();
  System.out.println("ActionListener: directory name: "+base);
  root.removeAllChildren();
  updateTree(base);
  System.out.println("After updateTree");
  reload();
  System.out.println("ActionListener:inside FileTreeModel");
}
  
public  int  updateTree(String base)
{
  String s;
  DefaultMutableTreeNode parent=null;
     
  System.out.println("Filter :updateTree base "+base);
        
  attributeVector subtree = searchFull (base);
  System.out.println("We will add "+subtree.size()+" entries !!!");

  attributeVector entry = (attributeVector)(subtree.elementAt(0));
  root.setUserObject(entry);
  
  for(int k=1;k<subtree.size();k++){
    entry = (attributeVector)(subtree.elementAt(k));
    parent = findParent(entry);
    parent.add(new DefaultMutableTreeNode(entry));  
  }
  return subtree.size();
}

public void getSelectedDirContent(TreePath selPath)
  {
    DefaultMutableTreeNode lastComponent = (DefaultMutableTreeNode)
                                           selPath.getLastPathComponent();
    TreeNode removedOne = lastComponent.getChildAt(0); 

    //Construct subtree
    String selectedDir = getSelectedItem(selPath);
    
    lastComponent.removeAllChildren();
    int childCnt = updateTree(selectedDir);
    	
    //announce dummy child is removed
    int[] childIndices = new int[1];
    childIndices[0] = 0;
    TreeNode[] removedChildren = new TreeNode[1];
    removedChildren[0] = removedOne;
    nodesWereRemoved((TreeNode)lastComponent,childIndices,
			  removedChildren);

    //announce some children added to current node	
    childIndices = new int[childCnt];
    for(int i=0;i<childCnt;i++) childIndices[i] = i;
    nodesWereInserted((TreeNode)lastComponent,childIndices);

  }
  
public String getSelectedItem(TreePath selPath)
  {
    int pcount = selPath.getPathCount();
    TreeNode tn = (TreeNode)(selPath.getPathComponent(pcount-1));
    Object o = ((DefaultMutableTreeNode)tn).getUserObject();
    attributeVector tinfo = (attributeVector)o;
    String dn = (String)(tinfo.elementAt(0));
    System.out.println("Selected dn : "+dn);
    return dn;
  }

public void treeExpanded(TreeExpansionEvent event)
  {
    System.out.println("treeExpanded is Called !!");
  
    TreePath selPath = event.getPath();
    System.out.println("selPath "+selPath.toString());
    System.out.println("selPath count ="+selPath.getPathCount());
        
      String newDirName = getSelectedItem(selPath);
      System.out.println("newDirName "+newDirName);
      
      if (newDirName.lastIndexOf("/") == newDirName.length() -1){
	getSelectedDirContent(selPath);
	System.out.println("Getting Ne directory contents: "+newDirName);
      }
    
  }

public void treeCollapsed(TreeExpansionEvent event)
  {
    System.out.println("treeCollapsed is Called !!");
  }


}

class attributeVector 
{
  Vector data;

  public attributeVector(Object obj)
  {
    data = new Vector();
    addElement(obj);
    
  }

  public attributeVector()
  {
    data = new Vector();
  }
  
  public attributeVector(int elems)
  {
    data = new Vector(elems);
  }

  public Object elementAt(int index)
  {
    return data.elementAt(index);
  }
  
  public void addElement(Object item)
  {
    data.addElement(item);
  }

public int size()
  {
    return data.size();
  }
  

  public String toString()
  {
    String name = (String)(data.elementAt(0));
    if (name.indexOf(',') != name.lastIndexOf(',') )
      name = name.substring(0,name.indexOf(','));
    
    return name;
  }
  
}

